import Data.Monoid
import Data.Foldable hiding (sum)
import Control.Applicative
import Prelude hiding (sum)


{- instance Monoid [a] where
      mappend = (++)
      mempty = []-}

-- todo implement plus and product monoid      
data Min a = Min a | MinEmpty deriving (Show)
           
data Max a = Max a | MaxEmpty deriving (Show)

newtype Count = Count Int deriving (Show)

instance (Ord a) => Monoid (Min a) where
  mempty = MinEmpty
  mappend MinEmpty m = m
  mappend m MinEmpty = m
  mappend (Min a) (Min b) = (Min (Prelude.min a b))

instance (Ord a) => Monoid (Max a) where
  mempty = MaxEmpty
  mappend MaxEmpty m = m
  mappend m MaxEmpty = m
  mappend (Max a) (Max b) = (Max (Prelude.max a b))

instance Monoid Count where
  mempty = Count 0
  mappend (Count n1) (Count n2) = Count (n1+n2)

sum :: (Num a) => a -> Sum a
sum = Sum

sumOfList   :: Num a => [a] -> Sum a
sumOfList a =  mconcat $ fmap Sum a

product :: (Num a) => a -> Product a
product = Product

productOfList   :: Num a => [a] -> Product a
productOfList a =  mconcat $ fmap Product a

min :: (Ord a) => a -> Min a
min = Min

minOfList   :: Ord a => [a] -> Min a
-- minOfList a =  mconcat $ fmap Min a
minOfList a =  foldMap Min a

max :: (Ord a) => a -> Max a
max = Max

maxOfList   :: Ord a => [a] -> Max a
-- maxOfList a =  mconcat $ fmap Max a
maxOfList a =  foldMap Max a

count :: a -> Count
count _ = Count 1

countOfList :: Foldable t => t a -> Count
-- countOfList a =  mconcat $ fmap count a
countOfList a =  foldMap count a

